/**
* Wszystkie prawa zastrzeone.
* Autor: Tomasz Kaczanowski
* Licencja: Kod mona modyfikowa, oraz uy we wasnych rozwizaniach nieodpatnie,
* jedyny wymg - konieczno podania w dokumentacji informacji o wykorzystaniu kodu
* oraz autora - Tomasza Kaczanowskiego. Jeli jest jaka informacja o programie
* - rwnie tam naley umieci adekwatn informacj.
*/
#include "mytextobj.h"
#include "mydefaultobj.h"
#include <stdio.h>

struct myTextObj
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    char *buftext;
    int allocmemsize;
};


static void myTextObjDestructor(struct TDefaultObj *aval)
{
    struct myTextObj *lptr = (struct myTextObj *)aval;
    if (lptr)
    {
        if (lptr->buftext)
        {
            free(lptr->buftext);
        }
        free(lptr);
    }

}

static struct TDefaultObj *myTextObjClone(struct TDefaultObj *aval)
{
    struct myTextObj *lptr = (struct myTextObj *)aval;
    struct myTextObj *lres = NULL;
    int lsize;
    if (lptr)
    {
        lres = (struct myTextObj *)malloc(sizeof(struct myTextObj));
        if (lres)
        {
            memcpy(lres, lptr, sizeof(struct myTextObj));
            if (lptr->buftext)
            {
                lsize = strlen(lptr->buftext) + 1;
                lres->buftext = (char *)malloc(lsize);
                if (lres->buftext)
                {
                	strcpy(lres->buftext, lptr->buftext);
                    lres->allocmemsize = lsize;
                }

        	}
        }
	}
    return (struct TDefaultObj *)lres;
}

struct myTextObj *CreateTextObj(const char* astr)
{
    struct myTextObj *lres = (struct myTextObj *)malloc(sizeof(struct myTextObj));
    int lsize = strlen(astr) + 1;
    if (lres)
    {

        lres->buftext = (char *)malloc(lsize);
        if (lres->buftext)
        {
        	strcpy(lres->buftext, astr);
            lres->allocmemsize = lsize;
        }

        lres->fooDestructor = myTextObjDestructor;
        lres->fooGetSize = NULL;
        lres->fooCloneObj = myTextObjClone;
    }
    return lres;
}

int SetTextObjValue(struct myTextObj *aobj, const char *astr)
{
    int lsize = strlen(astr);
    if (aobj->allocmemsize > lsize)
    {
        strcpy(aobj->buftext, astr);
        return 1;
	}
    else
    {
        strncpy(aobj->buftext, astr, aobj->allocmemsize);
        return -1;
    }


}

void PrintTextObjValue(struct myTextObj *aobj)
{
    printf("wartosc obiektu to: \"%s\"\n", aobj->buftext);
}

